## mono 6.14.1+ds2

=== mcs/Makefile ===
thisdir := .

SUBDIRS := build jay mcs class ilasm tools tests errors docs packages

# Resgen is corlib specific tool

build_SUBDIRS := build jay tools/gensources class class/aot-compiler tools
monodroid_SUBDIRS := build class tools
monodroid_tools_SUBDIRS := build class tools
monotouch_SUBDIRS := build class tools
monotouch_watch_SUBDIRS := build class
monotouch_tv_SUBDIRS := build class
monotouch_runtime_SUBDIRS := build class
monotouch_watch_runtime_SUBDIRS := build class
monotouch_tv_runtime_SUBDIRS := build class
monotouch_tools_SUBDIRS := build class tools
xammac_SUBDIRS := build class
testing_aot_full_interp_SUBDIRS := build class
testing_aot_hybrid_SUBDIRS := build class
testing_aot_full_SUBDIRS := build class
binary_reference_assemblies_SUBDIRS := build class
net_4_x_SUBDIRS := build class ilasm tools tests errors docs mcs class/aot-compiler packages
xammac_net_4_5_SUBDIRS := build class
xbuild_12_SUBDIRS := build class tools/xbuild
xbuild_14_SUBDIRS := build class tools/xbuild
winaot_SUBDIRS := build class
testing_winaot_interp_SUBDIRS := build class
orbis_SUBDIRS := build class
unreal_SUBDIRS := build class
wasm_SUBDIRS := build class
wasm_tools_SUBDIRS := build class tools

include build/rules.make

all-recursive $(STD_TARGETS:=-recursive): dir-check platform-check profile-check

.PHONY: all-local $(STD_TARGETS:=-local)
all-local $(STD_TARGETS:=-local):
	@:

dir-check:
	@if [ "$(NO_DIR_CHECK)" = "" ]; then $(MAKE) -C ../runtime; fi

# fun specialty targets

PROFILES = net_4_x binary_reference_assemblies xbuild_12 xbuild_14

.PHONY: all-profiles compiler-test-profiles run-compiler-test-profiles $(STD_TARGETS:=-profiles)
all-profiles compiler-test-profiles run-compiler-test-profiles $(STD_TARGETS:=-profiles): %-profiles: profiles-do--%
	@:

profiles-do--%:
	$(if $(PROFILES),$(MAKE) $(PROFILES:%=profile-do--%--$*))

# The % below looks like profile-name--target-name
profile-do--%:
	$(MAKE) PROFILE=$(subst --, ,$*)

# xbuild_12 and xbuild_14 will try to install the same files, so they need
# to be ordered
profile-do--xbuild_14--install: profile-do--xbuild_12--install
profile-do--xbuild_14--test: profile-do--xbuild_12--test

# We don't want to run the tests in parallel.  We want behaviour like -k.
profiles-do--run-test:
	ret=:; $(foreach p,$(PROFILES), { $(MAKE) PROFILE=$(p) run-test || ret=false; }; ) $$ret

# Orchestrate the bootstrap here.
_boot_ = all clean install
$(_boot_:%=profile-do--xbuild_14--%):         profile-do--xbuild_14--%:         profile-do--net_4_x--%
$(_boot_:%=profile-do--xbuild_12--%):         profile-do--xbuild_12--%:         profile-do--net_4_x--%
$(_boot_:%=profile-do--binary_reference_assemblies--%):           profile-do--binary_reference_assemblies--%:           profile-do--build--%
$(_boot_:%=profile-do--net_4_x--%):           profile-do--net_4_x--%:           profile-do--build--%
$(_boot_:%=profile-do--monodroid--%):         profile-do--monodroid--%:         profile-do--build--%
$(_boot_:%=profile-do--monodroid_tools--%):         profile-do--monodroid_tools--%:         profile-do--build--%
$(_boot_:%=profile-do--monotouch--%):         profile-do--monotouch--%:         profile-do--build--%
$(_boot_:%=profile-do--monotouch_watch--%):   profile-do--monotouch_watch--%:   profile-do--build--%
$(_boot_:%=profile-do--monotouch_tv--%):      profile-do--monotouch_tv--%:      profile-do--build--%
$(_boot_:%=profile-do--monotouch_runtime--%):  profile-do--monotouch_runtime--%:  profile-do--build--%
$(_boot_:%=profile-do--monotouch_watch_runtime--%):  profile-do--monotouch_watch_runtime--%:  profile-do--build--%
$(_boot_:%=profile-do--monotouch_tv_runtime--%):     profile-do--monotouch_tv_runtime--%:     profile-do--build--%
$(_boot_:%=profile-do--monotouch_tools--%):         profile-do--monotouch_tools--%:         profile-do--build--%
$(_boot_:%=profile-do--xammac--%):            profile-do--xammac--%:            profile-do--build--%
$(_boot_:%=profile-do--xammac_net_4_5--%):    profile-do--xammac_net_4_5--%:           profile-do--build--%
$(_boot_:%=profile-do--testing_aot_full_interp--%):        profile-do--testing_aot_full_interp--%:        profile-do--build--%
$(_boot_:%=profile-do--testing_aot_hybrid--%):        profile-do--testing_aot_hybrid--%:        profile-do--build--%
$(_boot_:%=profile-do--testing_aot_full--%):          profile-do--testing_aot_full--%:          profile-do--build--%
$(_boot_:%=profile-do--winaot--%):              profile-do--winaot--%:              profile-do--build--%
$(_boot_:%=profile-do--testing_winaot_interp--%):     profile-do--testing_winaot_interp--%:              profile-do--build--%
$(_boot_:%=profile-do--orbis--%):              profile-do--orbis--%:              profile-do--build--%
$(_boot_:%=profile-do--unreal--%):              profile-do--unreal--%:              profile-do--build--%
$(_boot_:%=profile-do--wasm--%):              profile-do--wasm--%:              profile-do--build--%
$(_boot_:%=profile-do--wasm_tools--%):         profile-do--wasm_tools--%:         profile-do--build--%

compiler-test:
	$(MAKE) -C tests test
	$(MAKE) -C errors test

run-compiler-test:
	$(MAKE) -C tests run-test
	$(MAKE) -C errors run-test

package := mcs-$(VERSION)

DISTFILES = \
	AUTHORS			\
	COPYING			\
	INSTALL.txt		\
	Makefile		\
	mkinstalldirs		\
	MonoIcon.png		\
	README			\
	ScalableMonoIcon.svg

dist-local: dist-default

dist-pre:
	rm -rf $(package)
	mkdir $(package)

dist-tarball: dist-pre
	$(MAKE) distdir='$(package)' dist-recursive
	tar cvjf $(package).tar.bz2 $(package)

dist: dist-tarball
	rm -rf $(package)

# the grep -E -v is kind of a hack (to get rid of the makefrags)
# but otherwise we have to make dist then make clean which
# is sort of not kosher. And it breaks with DIST_ONLY_SUBDIRS.
#
# We need to set prefix on make so class/System/Makefile can find
# the installed System.Xml to build properly

distcheck: dist-tarball
	rm -rf InstallTest Distcheck-MCS ; \
	mkdir InstallTest ; \
	destdir=`cd InstallTest && pwd` ; \
	mv $(package) Distcheck-MCS ; \
	(cd Distcheck-MCS && \
	    $(MAKE) prefix=$(prefix) && $(MAKE) test && $(MAKE) install DESTDIR="$$destdir" && \
	    $(MAKE) clean && $(MAKE) dist || exit 1) || exit 1 ; \
	mv Distcheck-MCS $(package) ; \
	tar tjf $(package)/$(package).tar.bz2 |sed -e 's,/$$,,' |sort >distdist.list ; \
	rm $(package)/$(package).tar.bz2 ; \
	tar tjf $(package).tar.bz2 |sed -e 's,/$$,,' |sort >before.list ; \
	find $(package) |grep -E -v '(makefrag|response)' |sed -e 's,/$$,,' |sort >after.list ; \
	cmp before.list after.list || exit 1 ; \
	cmp before.list distdist.list || exit 1 ; \
	rm -f before.list after.list distdist.list ; \
	rm -rf $(package) InstallTest

# Targets for creating API diffs of the framework

MONO_API_SNAPSHOT_PATH := $(topdir)../external/api-snapshot/
GENAPI := $(MONO_API_SNAPSHOT_PATH)tools/genapi/Microsoft.DotNet.GenAPI.exe
MONO_API_SNAPSHOT_PROFILE_PATH := $(MONO_API_SNAPSHOT_PATH)profiles/$(PROFILE)/
MONO_API_ASSEMBLIES_IGNORED := $(addprefix $(topdir)class/lib/$(PROFILE)/, Mono.CSharp.dll SystemWebTestShim.dll standalone-runner-support.dll nunitlite.dll Mono.Profiler.Log.dll Mono.Debugger.Soft.dll)
MONO_API_ASSEMBLIES := $(filter-out $(MONO_API_ASSEMBLIES_IGNORED), $(wildcard $(topdir)class/lib/$(PROFILE)/*.dll)) $(wildcard $(topdir)class/lib/$(PROFILE)/Facades/*.dll)
MONO_API_ASSEMBLIES_CS := $(MONO_API_ASSEMBLIES:$(topdir)class/lib/$(PROFILE)/%.dll=$(MONO_API_SNAPSHOT_PROFILE_PATH)%.cs)

apidiff/ignored-attr.txt:
	@mkdir -p $(dir $@)
	@echo "T:System.Runtime.CompilerServices.CompilerGeneratedAttribute" > $@

$(MONO_API_SNAPSHOT_PROFILE_PATH)%.cs: $(topdir)class/lib/$(PROFILE)/%.dll $(GENAPI) $(MONO_API_SNAPSHOT_PATH)profiles/license-header.txt apidiff/ignored-attr.txt
	@mkdir -p $(dir $@)
	$(Q) MONO_PATH=$(topdir)class/lib/$(BUILD_TOOLS_PROFILE) $(RUNTIME) $(GENAPI) -libPath:$(topdir)class/lib/$(PROFILE),$(topdir)class/lib/$(PROFILE)/Facades -out:$(dir $@) -headerFile:$(MONO_API_SNAPSHOT_PATH)profiles/license-header.txt -assemblyAttributes -typeForwardedTo -assemblyVersion -excludeAttributesList:apidiff/ignored-attr.txt -assembly:$< || echo "Couldn't process assembly." > $@

mono-api-current: $(MONO_API_ASSEMBLIES_CS)

mono-api-current-clean:
	$(Q) find "$(MONO_API_SNAPSHOT_PROFILE_PATH)" -name "*.cs" -type f -delete

mono-api-diff:
	@echo "Regenerating API snapshot..."
	$(Q) $(MAKE) mono-api-current-clean PROFILE=net_4_x
	$(Q) $(MAKE) mono-api-current-clean PROFILE=monotouch
	$(Q) $(MAKE) mono-api-current-clean PROFILE=monodroid
	$(Q) $(MAKE) mono-api-current PROFILE=net_4_x
	$(Q) $(MAKE) mono-api-current PROFILE=monotouch
	$(Q) $(MAKE) mono-api-current PROFILE=monodroid
	@echo "Checking public API differences..."
	$(Q) cd $(MONO_API_SNAPSHOT_PATH); git add -A .
	$(Q) cd $(MONO_API_SNAPSHOT_PATH); git diff --no-renames HEAD > $(abspath $(topdir))/temp.patch
	@mkdir -p apidiff
	$(Q) sed -e "/@diffdata@/r temp.patch" -e "/@diffdata@/d" -e "s/@title@/Public API Diff/g" -e "s/@description@/If the changes are intentional, run <code>make -C mcs mono-api-diff<\/code> locally and commit changes in external\/api-snapshot./g" diff.html.in > apidiff/index.html
	$(Q) if [ -s temp.patch ]; then echo "Error: Found public API differences, see mcs/apidiff/index.html. If the changes are intentional, please go to external/api-snapshot and commit them."; rm -f temp.patch; exit 1; else echo "No differences found."; rm -f temp.patch; fi

=== external/api-doc-tools/Makefile ===
MSBUILD = msbuild
CONFIGURATION = Release
BIN = bin/$(CONFIGURATION)
MDOC = $(BIN)/mdoc.exe

all: build

build: $(MDOC)

$(MDOC):
	$(MSBUILD) apidoctools.sln /p:Configuration=$(CONFIGURATION);

prepare:
	git submodule update --init --recursive
	nuget restore apidoctools.sln
	nuget install NUnit.Console -version 3.6.0 -NoCache -o packages

clean:
	#$(MSBUILD) apidoctools.sln /t:clean
	rm -rf bin/$(CONFIGURATION)

check: build check-monodoc check-mdoc

check-mdoc:
	cd mdoc; $(MAKE) check -B

nuget:
	nuget pack mdoc/mdoc.nuspec -outputdirectory bin/Nuget

check-monodoc:
	cd monodoc; $(MAKE) check -B

=== external/binary-reference-assemblies/Makefile ===
all:
	$(MAKE) -C v2.0
	$(MAKE) -C v3.5
	$(MAKE) -C v4.0
	$(MAKE) -C v4.5
	$(MAKE) -C v4.5.1
	$(MAKE) -C v4.5.2
	$(MAKE) -C v4.6
	$(MAKE) -C v4.6.1
	$(MAKE) -C v4.6.2
	$(MAKE) -C v4.7
	$(MAKE) -C v4.7.1
	$(MAKE) -C v4.7.2
	$(MAKE) -C v4.8
	$(MAKE) -C mono
	$(MAKE) -C build/monotouch
	$(MAKE) -C build/monodroid
	$(MAKE) -C build/monowasm	

clean:
	$(MAKE) -C v2.0 clean
	$(MAKE) -C v3.5 clean
	$(MAKE) -C v4.0 clean
	$(MAKE) -C v4.5 clean
	$(MAKE) -C v4.5.1 clean
	$(MAKE) -C v4.5.2 clean
	$(MAKE) -C v4.6 clean
	$(MAKE) -C v4.6.1 clean
	$(MAKE) -C v4.6.2 clean
	$(MAKE) -C v4.7 clean
	$(MAKE) -C v4.7.1 clean
	$(MAKE) -C v4.7.2 clean
	$(MAKE) -C v4.8 clean
	$(MAKE) -C mono clean
	$(MAKE) -C build/monotouch clean
	$(MAKE) -C build/monodroid clean
	$(MAKE) -C build/monowasm clean

.PHONY: all clean

=== external/boringssl/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10...4.0)

# Defer enabling C and CXX languages.
project (BoringSSL NONE)

if(WIN32)
  # On Windows, prefer cl over gcc if both are available. By default most of
  # the CMake generators prefer gcc, even on Windows.
  set(CMAKE_GENERATOR_CC cl)
endif()

enable_language(C)
enable_language(CXX)

if(ANDROID)
  # Android-NDK CMake files reconfigure the path and so Go and Perl won't be
  # found. However, ninja will still find them in $PATH if we just name them.
  if(NOT OPENSSL_NO_ASM)
    set(PERL_EXECUTABLE "perl")
  endif()
  # set(GO_EXECUTABLE "go")
else()
  if(NOT OPENSSL_NO_ASM)
    find_package(Perl REQUIRED)
  endif()
  # find_program(GO_EXECUTABLE go)
endif()

#if (NOT GO_EXECUTABLE)
#  message(FATAL_ERROR "Could not find Go")
#endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  if(${CMAKE_SYSTEM_NAME} MATCHES "AIX" OR ${CMAKE_SYSTEM_NAME} MATCHES "OS400")
    # XCOFF doesn't support -fvisibility=hidden, and we would prefer XCOFF debugging info.
    set(C_CXX_FLAGS "-Wall -Wformat=2 -Wsign-compare -Wmissing-field-initializers -gxcoff")
  else()
    set(C_CXX_FLAGS "-Wall -Wformat=2 -Wsign-compare -Wmissing-field-initializers -ggdb -fvisibility=hidden")
  endif()
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_CXX_FLAGS}")
  if(ANDROID)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x ${C_CXX_FLAGS}")
  elseif(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 ${C_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -stdlib=libc++ ${C_CXX_FLAGS}")
  endif()
elseif(MSVC)
  set(MSVC_DISABLED_WARNINGS_LIST
      "C4100" # 'exarg' : unreferenced formal parameter
      "C4127" # conditional expression is constant
      "C4200" # nonstandard extension used : zero-sized array in
              # struct/union.
      "C4242" # 'function' : conversion from 'int' to 'uint8_t',
              # possible loss of data
      "C4244" # 'function' : conversion from 'int' to 'uint8_t',
              # possible loss of data
      "C4245" # 'initializing' : conversion from 'long' to
              # 'unsigned long', signed/unsigned mismatch
      "C4267" # conversion from 'size_t' to 'int', possible loss of data
      "C4371" # layout of class may have changed from a previous version of the
              # compiler due to better packing of member '...'
      "C4388" # signed/unsigned mismatch
      "C4296" # '>=' : expression is always true
      "C4350" # behavior change: 'std::_Wrap_alloc...'
      "C4365" # '=' : conversion from 'size_t' to 'int',
              # signed/unsigned mismatch
      "C4389" # '!=' : signed/unsigned mismatch
      "C4464" # relative include path contains '..'
      "C4510" # 'argument' : default constructor could not be generated
      "C4512" # 'argument' : assignment operator could not be generated
      "C4514" # 'function': unreferenced inline function has been removed
      "C4548" # expression before comma has no effect; expected expression with
              # side-effect" caused by FD_* macros.
      "C4610" # struct 'argument' can never be instantiated - user defined
              # constructor required.
      "C4623" # default constructor was implicitly defined as deleted
      "C4625" # copy constructor could not be generated because a base class
              # copy constructor is inaccessible or deleted
      "C4626" # assignment operator could not be generated because a base class
              # assignment operator is inaccessible or deleted
      "C4706" # assignment within conditional expression
      "C4710" # 'function': function not inlined
      "C4711" # function 'function' selected for inline expansion
      "C4800" # 'int' : forcing value to bool 'true' or 'false'
              # (performance warning)
      "C4820" # 'bytes' bytes padding added after construct 'member_name'
      "C5027" # move assignment operator was implicitly defined as deleted
      "C5045" # compiler will insert Spectre mitigation for memory load
              # if /Qspectre switch specified
      "C4668" # 'symbol' is not defined as a preprocessor macro, replacing with '0' for 'directives'
      )
  set(MSVC_LEVEL4_WARNINGS_LIST
      # See https://connect.microsoft.com/VisualStudio/feedback/details/1217660/warning-c4265-when-using-functional-header
      "C4265" # class has virtual functions, but destructor is not virtual
      )
  string(REPLACE "C" " -wd" MSVC_DISABLED_WARNINGS_STR
                            ${MSVC_DISABLED_WARNINGS_LIST})
  string(REPLACE "C" " -w4" MSVC_LEVEL4_WARNINGS_STR
                            ${MSVC_LEVEL4_WARNINGS_LIST})
  set(CMAKE_C_FLAGS   "-Wall -WX ${MSVC_DISABLED_WARNINGS_STR} ${MSVC_LEVEL4_WARNINGS_STR}")
  set(CMAKE_CXX_FLAGS "-Wall -WX ${MSVC_DISABLED_WARNINGS_STR} ${MSVC_LEVEL4_WARNINGS_STR}")
  add_definitions(-D_HAS_EXCEPTIONS=0)
  add_definitions(-DWIN32_LEAN_AND_MEAN)
  add_definitions(-DNOMINMAX)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS) # Allow use of fopen
endif()

if((CMAKE_COMPILER_IS_GNUCXX AND CMAKE_C_COMPILER_VERSION VERSION_GREATER "4.7.99") OR
   CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wshadow")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  if ((CMAKE_C_COMPILER_VERSION VERSION_GREATER "4.8.99") OR
      CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11")
  else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
  endif()
endif()

# pthread_rwlock_t requires a feature flag.
if(NOT WIN32)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_XOPEN_SOURCE=700")
endif()

if(FUZZ)
  if(!CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message("You need to build with Clang for fuzzing to work")
  endif()

  add_definitions(-DBORINGSSL_UNSAFE_FUZZER_MODE)
  set(RUNNER_ARGS "-fuzzer")

  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fsanitize-coverage=edge,indirect-calls,8bit-counters")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fsanitize-coverage=edge,indirect-calls,8bit-counters")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address")
  link_directories(.)
endif()

add_definitions(-DBORINGSSL_IMPLEMENTATION)

if (BUILD_SHARED_LIBS)
  add_definitions(-DBORINGSSL_SHARED_LIBRARY)
  # Enable position-independent code globally. This is needed because
  # some library targets are OBJECT libraries.
  set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
endif()

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64")
  set(ARCH "x86_64")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "amd64")
  set(ARCH "x86_64")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "AMD64")
  # cmake reports AMD64 on Windows, but we might be building for 32-bit.
  if (CMAKE_CL_64)
    set(ARCH "x86_64")
  else()
    set(ARCH "x86")
  endif()
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86")
  set(ARCH "x86")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i386")
  set(ARCH "x86")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i686")
  set(ARCH "x86")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "arm")
  set(ARCH "arm")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "armv5te")
  set(ARCH "arm")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "armv6")
  set(ARCH "arm")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "armv7-a")
  set(ARCH "arm")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "aarch64")
  set(ARCH "aarch64")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "s390x")
  set(ARCH "s390x")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "powerpc")
  set(ARCH "powerpc")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "riscv32")
  set(ARCH "riscv32")
elseif (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "riscv64")
  set(ARCH "riscv64")
else()
  message(FATAL_ERROR "Unknown processor:" ${CMAKE_SYSTEM_PROCESSOR})
endif()

if (ANDROID AND ${ARCH} STREQUAL "arm")
  # The Android-NDK CMake files somehow fail to set the -march flag for
  # assembly files. Without this flag, the compiler believes that it's
  # building for ARMv5.
  if (NOT OPENSSL_NO_ASM)
    set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -march=${CMAKE_SYSTEM_PROCESSOR}")
  endif()
endif()

# if (${ARCH} STREQUAL "x86" AND APPLE)
  # With CMake 2.8.x, ${CMAKE_SYSTEM_PROCESSOR} evalutes to i386 on OS X,
  # but clang defaults to 64-bit builds on OS X unless otherwise told.
  # Set ARCH to x86_64 so clang and CMake agree. This is fixed in CMake 3.
#  set(ARCH "x86_64")
#endif()

if (OPENSSL_NO_ASM)
  add_definitions(-DOPENSSL_NO_ASM)
  set(ARCH "generic")
endif()

# Declare a dummy target to build all unit tests. Test targets should inject
# themselves as dependencies next to the target definition.
if(ENABLE_TESTS)
add_custom_target(all_tests)
endif()

add_subdirectory(crypto)
add_subdirectory(ssl)
if(ENABLE_TESTS)
add_subdirectory(ssl/test)
endif()
if(ENABLE_TOOL)
add_subdirectory(tool)
endif()
if(ENABLE_DECREPIT)
add_subdirectory(decrepit)
endif()

if(FUZZ)
  add_subdirectory(fuzz)
endif()

if (NOT ${CMAKE_VERSION} VERSION_LESS "3.2")
  # USES_TERMINAL is only available in CMake 3.2 or later.
  set(MAYBE_USES_TERMINAL USES_TERMINAL)
endif()

set (
	BORINGSSL_OBJECTS
	$<TARGET_OBJECTS:crypto-objects>
	${crypto_objects_dependencies}
	$<TARGET_OBJECTS:ssl-objects>
	${ssl_objects_dependencies}
	PARENT_SCOPE
)

# add_custom_target(
#     run_tests
#     COMMAND ${GO_EXECUTABLE} run util/all_tests.go -build-dir
#             ${CMAKE_BINARY_DIR}
#     COMMAND cd ssl/test/runner
#     COMMAND ${GO_EXECUTABLE} test -shim-path $<TARGET_FILE:bssl_shim>
#     WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
#     DEPENDS all_tests bssl_shim
#     ${MAYBE_USES_TERMINAL})

=== mcs/build/Makefile ===
thisdir = build
SUBDIRS = 
include ../build/rules.make

BUILT_FILES = common/Consts.cs $(topdir)/class/lib/$(PROFILE_DIRECTORY)/Consts.cs common/sourcelink.json

all-local install-local test-local run-test-local run-test-ondotnet-local uninstall-local doc-update-local: $(BUILT_FILES)
	@:

clean-local:
	-rm -f $(BUILT_FILES) deps/*

$(topdir)/class/lib/$(PROFILE_DIRECTORY):
	mkdir -p $@

common/Consts.cs $(topdir)/class/lib/$(PROFILE_DIRECTORY)/Consts.cs: common/Consts.cs.in $(wildcard config.make) | $(topdir)/class/lib/$(PROFILE_DIRECTORY)
	test -n '$(MONO_VERSION)'
	test -n '$(MONO_CORLIB_VERSION)'
	sed -e 's,@''MONO_VERSION@,$(MONO_VERSION),' -e 's,@''MONO_CORLIB_VERSION@,$(MONO_CORLIB_VERSION),' $< > $@

common/sourcelink.json: common/sourcelink.json.in $(wildcard config.make) | $(topdir)/class/lib/$(PROFILE_DIRECTORY)
	sed -e 's,@mono_topdir@,$(shell cd $(topdir)/.. && pwd),' -e 's,@mono_commit_hash@,$(shell cd $(topdir)/.. && git rev-parse HEAD),' -e 's,@corefx_commit_hash@,$(shell cd $(topdir)/../external/corefx && git rev-parse HEAD),' -e 's,@corert_commit_hash@,$(shell cd $(topdir)/../external/corert && git rev-parse HEAD),' -e 's,@cecil_commit_hash@,$(shell cd $(topdir)/../external/cecil && git rev-parse HEAD),' $< > $@

PLATFORMS = macos linux win32 unix
PROFILES = \
	build \
	binary_reference_assemblies \
	net_4_x \
	xbuild_12 \
	xbuild_14

COMMON_SRCS = \
	Consts.cs.in			\
	sourcelink.json.in	\
	Locale.cs			\
	MonoTODOAttribute.cs \
	basic-profile-check.cs		\
	SR.cs	\
	AssemblyRef.cs

DISTFILES = \
	README.makefiles.md		\
	README.platforms		\
	README.configury		\
	config-default.make		\
	corcompare.make			\
	corcompare-api.xsl		\
	executable.make			\
	library.make			\
	rules.make			\
	tests.make			\
	start-compiler-server.sh	\
	$(COMMON_SRCS:%=common/%)	\
	$(PLATFORMS:%=platforms/%.make) $(PROFILES:%=profiles/%.make)

dist-local: dist-default

=== mcs/class/Makefile ===
thisdir = class

NO_FACADES_PROFILE := $(filter monodroid_tools monotouch_tools wasm_tools binary_reference_assemblies xbuild_12 xbuild_14, $(PROFILE))

ifndef NO_FACADES_PROFILE
FACADES_FOLDER := Facades
endif

-include ../build/config.make

ifdef MCS_MODE
MCS_MODE_dirs := Mono.Cecil.Mdb
endif

# Tooling dependencies of mscorlib, we build them to /tmp folder for MONO_PATH to work
# reliably for clean and update builds. All deps are built against stable API to run with
# range of boostrap versions and .NET at the same time
build_SUBDIRS = \
	Mono.Cecil \
	$(MCS_MODE_dirs) \
	../tools/cil-stringreplacer \
	PEAPI \
	../ilasm \
	corlib

build_PARALLEL_SUBDIRS = \
	Mono.Security \
	System \
	System.XML \
	System.Security \
	Mono.Posix \
	System.Core \
	System.Configuration \
	System.ComponentModel.Composition.4.5 \
	System.Numerics \
	System.Xml.Linq \
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.Net.Http \
	System.Net.Http.WebRequest \
	System.Drawing

ifdef MCS_MODE

build_SUBDIRS += \
	Mono.Security \
	System \
	System.XML \
	System.Security \
	Mono.Posix \
	System.Core \
	Mono.CompilerServices.SymbolWriter

build_PARALLEL_SUBDIRS += ../mcs
endif

mobile_common_dirs := \
	corlib

mobile_common_dirs_parallel := \
	Mono.Security \
	System	\
	System.Core	\
	System.XML	\
	System.Security	\
	I18N		\
	System.ServiceModel.Internals	\
	System.Runtime.Serialization	\
	System.Xml.Linq	\
	System.IdentityModel		\
	System.ServiceModel	\
	System.ServiceModel.Web	\
	System.Json	\
	System.Web.Services	\
	Mono.Data.Tds	\
	System.Transactions	\
	System.Numerics	\
	System.Numerics.Vectors		\
	System.Data	\
	System.Data.DataSetExtensions \
	Mono.Data.Sqlite	\
	System.Data.Services.Client \
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.ComponentModel.DataAnnotations \
	System.ComponentModel.Composition.4.5 \
	System.Net \
	System.Net.Http	\
	System.Windows \
	System.Xml.Serialization \
	Microsoft.CSharp \
	System.Reflection.Context	\
	System.Net.Http.WinHttpHandler \
	System.Runtime.CompilerServices.Unsafe

testing_aot_full_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.Simd \
	Mono.CSharp

testing_aot_full_interp_dirs_parallel := $(testing_aot_full_dirs_parallel)

testing_aot_hybrid_dirs_parallel := $(testing_aot_full_dirs_parallel)

xammac_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.CompilerServices.SymbolWriter	\
	Mono.CSharp

monodroid_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.CompilerServices.SymbolWriter	\
	Mono.Btls.Interface	\
	Mono.Posix \
	Mono.CSharp \
	Mono.Debugger.Soft \
	Mono.Runtime.Tests

monodroid_tools_dirs_parallel := \
	Mono.Cecil	\
	Mono.Cecil.Mdb	\
	Mono.CompilerServices.SymbolWriter \
	ICSharpCode.SharpZipLib	\
	monodoc \
	Mono.Debugger.Soft \
	Mono.Profiler.Log

monotouch_tools_dirs_parallel := \
	Mono.Cecil \
	Mono.Cecil.Mdb

monotouch_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.Simd \
	Mono.CSharp \
	Mono.Runtime.Tests

monotouch_watch_dirs_parallel := $(filter-out Mono.Security Mono.Data.Tds,$(monotouch_dirs_parallel))

monotouch_runtime_dirs_parallel := \
	Mono.Security \
	System \
	System.Core \
	System.XML \
	Mono.CSharp

monotouch_tv_dirs_parallel := $(monotouch_dirs_parallel)

monotouch_tv_runtime_dirs_parallel := $(monotouch_runtime_dirs_parallel)

monotouch_watch_runtime_dirs_parallel := \
	System \
	System.Core \
	System.XML \
	Mono.CSharp

monotouch_tv_runtime_dirs := \
	Mono.Security \
	$(monotouch_watch_runtime_dirs_parallel)

winaot_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.Simd

testing_winaot_interp_dirs_parallel := \
	$(mobile_common_dirs_parallel)	\
	Mono.Simd

unreal_dirs_parallel := \
	$(mobile_common_dirs_parallel)

wasm_dirs_parallel := \
	Mono.Security \
	System	\
	System.Core	\
	System.XML	\
	System.Security	\
	I18N		\
	System.Transactions	\
	System.ServiceModel.Internals	\
	System.Runtime.Serialization	\
	System.Data	\
	System.Data.DataSetExtensions	\
	System.Xml.Linq	\
	System.Numerics	\
	System.Numerics.Vectors		\
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.ComponentModel.DataAnnotations \
	System.ComponentModel.Composition.4.5 \
	System.Net.Http	\
	Microsoft.CSharp \
	System.Runtime.CompilerServices.Unsafe

wasm_tools_dirs_parallel := \
	Mono.Cecil

orbis_dirs_parallel := \
	$(filter-out Microsoft.CSharp Mono.Data.Sqlite,$(mobile_common_dirs_parallel))

xammac_4_5_dirs_parallel := \
	Mono.Security \
	System	\
	System.XML			\
	System.Security			\
	Mono.Posix	\
	System.Core	\
	System.Configuration	\
	I18N		\
	System.ServiceModel.Internals	\
	SMDiagnostics	\
	System.Numerics	\
	System.Numerics.Vectors		\
	Mono.Data.Tds	\
	System.Transactions	\
	System.EnterpriseServices	\
	System.Data	\
	System.Data.DataSetExtensions	\
	System.Runtime.Serialization	\
	System.Xml.Linq	\
	Mono.Data.Sqlite	\
	System.Runtime.Serialization.Formatters.Soap \
	System.ComponentModel.DataAnnotations \
	System.IdentityModel		\
	System.IdentityModel.Selectors	\
	Mono.Messaging			\
	System.Configuration.Install 	\
	System.Messaging	        \
	System.Web.Services \
	System.ServiceModel	\
	System.ServiceModel.Web	\
	System.Json	\
	System.Data.Services.Client \
	System.IO.Compression \
	System.IO.Compression.FileSystem \
	System.ComponentModel.Composition.4.5 \
	System.Net \
	System.Windows \
	System.Xml.Serialization \
	Mono.CSharp	\
	Microsoft.CSharp \
	Mono.CompilerServices.SymbolWriter	\
	System.Data.Linq		\
	System.Net.Http \
	System.Net.Http.WebRequest \
	System.Reflection.Context	\
	System.Net.Http.WinHttpHandler	\
	System.Runtime.CompilerServices.Unsafe

# Could be just mscorlib but we have unhandled dependency from RabbitMQ.Client.Apigen.exe
net_4_x_dirs := \
	corlib \
	Mono.Security \
	System	\
	System.XML

net_4_x_parallel_dirs = \
	System.Security			\
	Mono.Posix			\
	System.Core			\
	System.Configuration	\
	System.Drawing			\
	System.IO.Compression 		\
	System.IO.Compression.FileSystem \
	System.Transactions		\
	System.EnterpriseServices	\
	System.Numerics		\
	System.Numerics.Vectors		\
	System.Data		\
	System.ComponentModel.DataAnnotations	\
	Accessibility			\
	Mono.WebBrowser			\
	System.Runtime.Serialization.Formatters.Soap \
	System.Windows.Forms		\
	Mono.Data.Sqlite		\
	System.Web.ApplicationServices	\
	Novell.Directory.Ldap		\
	System.DirectoryServices	\
	System.Design			\
	System.Web.Services		\
	System.Web			\
	System.Runtime.Remoting		\
	System.Configuration.Install 	\
	System.Management		\
	System.Data.OracleClient	\
	Commons.Xml.Relaxng		\
	Mono.Messaging			\
	System.Messaging	        \
	System.ServiceProcess           \
	System.Drawing.Design		\
	ICSharpCode.SharpZipLib		\
	Microsoft.CSharp	\
	System.ServiceModel.Internals	\
	SMDiagnostics	\
	System.Runtime.Serialization	\
	System.Xml.Linq			\
	System.Data.Linq		\
	System.Web.Abstractions		\
	System.Web.Routing		\
	System.Runtime.DurableInstancing \
	System.IdentityModel		\
	System.IdentityModel.Selectors	\
	System.ServiceModel		\
	System.Web.Extensions		\
	System.Web.Extensions.Design	\
	System.Web.DynamicData		\
	System.Net			\
	System.Xaml \
	WindowsBase \
	System.ServiceModel.Activation \
	System.ServiceModel.Routing \
	System.ServiceModel.Discovery \
	System.Runtime.Caching \
	Microsoft.Web.Infrastructure \
	System.ServiceModel.Web \
	System.Net.Http	\
	System.Net.Http.WebRequest \
	System.Web.Razor \
	System.Web.WebPages.Deployment \
	System.Web.WebPages \
	System.Web.WebPages.Razor \
	System.Web.Mvc3 \
	System.Net.Http.Formatting \
	System.Web.Http \
	System.Web.Http.SelfHost \
	System.Web.Http.WebHost \
	CustomMarshalers		\
	IBM.Data.DB2			\
	PEAPI				\
	I18N				\
	Cscompmgd			\
	Mono.CompilerServices.SymbolWriter \
	Mono.Btls.Interface		\
	Mono.Http			\
	Mono.Cairo                      \
	Mono.Cecil			\
	Mono.Cecil.Mdb			\
	Mono.CSharp			\
	Mono.Debugger.Soft		\
	Mono.C5				\
	Mono.Management			\
	Mono.Options 			\
	Mono.Simd			\
	Mono.Tasklets       		\
	Mono.CodeContracts \
	Mono.Parallel \
	Mono.Security.Win32		\
	Mono.Messaging.RabbitMQ		\
	Mono.Data.Tds			\
	System.Dynamic			\
	System.Windows.Forms.DataVisualization	\
	System.Reactive.Interfaces \
	System.Reactive.Core \
	System.Reactive.Linq \
	System.Reactive.PlatformServices \
	System.Reactive.Providers \
	System.Reactive.Runtime.Remoting \
	System.Reactive.Windows.Forms \
	System.Reactive.Windows.Threading \
	System.Reactive.Observable.Aliases \
	System.Reactive.Experimental \
	System.Reactive.Debugger \
	System.Data.Services.Client	\
	System.Data.Services \
	System.Data.Entity \
	System.Data.DataSetExtensions	\
	System.Json		\
	System.Json.Microsoft \
	System.Threading.Tasks.Dataflow \
	System.ComponentModel.Composition.4.5 \
	System.Windows \
	System.Xml.Serialization \
	System.DirectoryServices.Protocols	\
	RabbitMQ.Client			\
	Microsoft.VisualC		\
	WebMatrix.Data \
	monodoc	\
	System.Deployment \
	System.Web.Mobile \
	System.Web.RegularExpressions \
	System.Workflow.Activities \
	System.Workflow.ComponentModel \
	System.Workflow.Runtime \
	System.Reflection.Context \
	Mono.Profiler.Log	\
	Mono.Runtime.Tests	\
	System.Runtime.CompilerServices.Unsafe \
	legacy/Mono.Cecil \
	SystemWebTestShim \
	$(xbuild_4_0_dirs)

xbuild_4_0_dirs := \
	Microsoft.Build.Framework	\
	Microsoft.Build.Utilities	\
	Microsoft.Build.Engine		\
	Mono.XBuild.Tasks		\
	Microsoft.Build.Tasks	\
	Microsoft.Build

monodroid_SUBDIRS := $(mobile_common_dirs)
monodroid_PARALLEL_SUBDIRS := $(monodroid_dirs_parallel)
monodroid_tools_SUBDIRS := 
monodroid_tools_PARALLEL_SUBDIRS := $(monodroid_tools_dirs_parallel)

monotouch_SUBDIRS := $(mobile_common_dirs)
monotouch_PARALLEL_SUBDIRS := $(monotouch_dirs_parallel)
monotouch_watch_SUBDIRS := $(mobile_common_dirs)
monotouch_watch_PARALLEL_SUBDIRS := $(monotouch_watch_dirs_parallel)
monotouch_tv_SUBDIRS    := $(mobile_common_dirs)
monotouch_tv_PARALLEL_SUBDIRS := $(monotouch_tv_dirs_parallel)
monotouch_runtime_SUBDIRS := $(mobile_common_dirs)
monotouch_runtime_PARALLEL_SUBDIRS := $(monotouch_runtime_dirs_parallel)
monotouch_watch_runtime_SUBDIRS := $(mobile_common_dirs)
monotouch_watch_runtime_PARALLEL_SUBDIRS := $(monotouch_watch_runtime_dirs_parallel)
monotouch_tv_runtime_SUBDIRS := $(mobile_common_dirs)
monotouch_tv_runtime_PARALLEL_SUBDIRS := $(monotouch_tv_runtime_dirs_parallel)
monotouch_tools_SUBDIRS :=
monotouch_tools_PARALLEL_SUBDIRS := $(monotouch_tools_dirs_parallel)

testing_aot_full_interp_SUBDIRS := $(mobile_common_dirs)
testing_aot_full_interp_PARALLEL_SUBDIRS := $(testing_aot_full_interp_dirs_parallel)
testing_aot_full_SUBDIRS := $(mobile_common_dirs)
testing_aot_full_PARALLEL_SUBDIRS := $(testing_aot_full_dirs_parallel)
testing_aot_hybrid_SUBDIRS := $(mobile_common_dirs)
testing_aot_hybrid_PARALLEL_SUBDIRS := $(testing_aot_hybrid_dirs_parallel)

xammac_SUBDIRS := $(mobile_common_dirs)
xammac_PARALLEL_SUBDIRS := $(xammac_dirs_parallel)
xammac_net_4_5_SUBDIRS := $(mobile_common_dirs)
xammac_net_4_5_PARALLEL_SUBDIRS := $(xammac_4_5_dirs_parallel)

binary_reference_assemblies_SUBDIRS := reference-assemblies
net_4_x_SUBDIRS := $(net_4_x_dirs)
net_4_x_PARALLEL_SUBDIRS := $(net_4_x_parallel_dirs)
xbuild_12_SUBDIRS := $(xbuild_4_0_dirs)
xbuild_14_SUBDIRS := $(xbuild_4_0_dirs) Microsoft.NuGet.Build.Tasks

winaot_SUBDIRS := $(mobile_common_dirs)
winaot_PARALLEL_SUBDIRS := $(winaot_dirs_parallel)

testing_winaot_interp_SUBDIRS := $(mobile_common_dirs)
testing_winaot_interp_PARALLEL_SUBDIRS := $(testing_winaot_interp_dirs_parallel)

orbis_SUBDIRS := $(mobile_common_dirs)
orbis_PARALLEL_SUBDIRS := $(orbis_dirs_parallel)

unreal_SUBDIRS := $(mobile_common_dirs)
unreal_PARALLEL_SUBDIRS := $(unreal_dirs_parallel)

wasm_SUBDIRS := $(mobile_common_dirs)
wasm_PARALLEL_SUBDIRS := $(wasm_dirs_parallel)
wasm_tools_SUBDIRS :=
wasm_tools_PARALLEL_SUBDIRS := $(wasm_tools_dirs_parallel)

include ../build/rules.make

DIST_SUBDIRS = $(testing_aot_full_dirs_parallel) $(testing_aot_hybrid_dirs_parallel) $(monotouch_dirs_parallel) $(monotouch_tools_dirs_parallel) \

=== mcs/docs/Makefile ===
thisdir = docs
SUBDIRS = 
include ../build/rules.make

DISTFILES = \
	clr-abi.txt                 \
	compiler.txt                \
	control-flow-analysis.txt   \
	cs-errors.config            \
	monodoc.xml                 \
	new-anonymous-design.txt    \
	order.txt                   \
	$(DOC_SOURCE_FILES)         \
	$(wildcard ecma334/*.xml)

DOC_SOURCE_FILES = \
	lang-csharp.source          \
	Mono.source                 \
	netdocs.source              \
	Novell.source

ASSEMBLED_DOCS = \
	cs-errors.tree cs-errors.zip      \
	ecma334.tree ecma334.zip          \
	Mono.tree Mono.zip                \
	netdocs.tree netdocs.zip          \
	Novell.tree Novell.zip            

MONODOC_SOURCES_INSTALL_FILES = \
	$(ASSEMBLED_DOCS)             \
	$(DOC_SOURCE_FILES)

CLEAN_FILES += $(ASSEMBLED_DOCS)

ifndef DISABLE_MCS_DOCS
ifneq ($(PROFILE), $(DEFAULT_PROFILE))
DISABLE_MCS_DOCS = yes
endif
endif

ifdef MCS_MODE
DISABLE_MCS_DOCS = yes
endif

test-local run-test-local run-test-ondotnet-local doc-update:

clean-local:
	-rm -f $(CLEAN_FILES)

dist-local: dist-default


MONODOC_INSTALL_DIR = $(DESTDIR)$(mono_libdir)/monodoc

ifdef DISABLE_MCS_DOCS
all-local:

install-local:

uninstall-local:

else
all-local: $(ASSEMBLED_DOCS)

install-local:
	$(MKINSTALLDIRS) $(MONODOC_INSTALL_DIR) $(MONODOC_INSTALL_DIR)/sources
	$(INSTALL_DATA) $(MONODOC_SOURCES_INSTALL_FILES) $(MONODOC_INSTALL_DIR)/sources
	$(INSTALL_DATA) monodoc.xml $(MONODOC_INSTALL_DIR)

uninstall-local:
	-rm -f $(MONODOC_INSTALL_DIR)/monodoc.xml
	-rm -f $(addprefix $(MONODOC_INSTALL_DIR)/sources/,$(MONODOC_SOURCES_INSTALL_FILES))
endif



classdir = $(topdir)/class
doc_en   = Documentation/en

NETDOCS_DIRS = \
	$(classdir)/corlib/$(doc_en)                                        \
	$(classdir)/System.Windows.Forms/$(doc_en)			    \
	$(classdir)/Microsoft.Build.Engine/$(doc_en)                        \
	$(classdir)/Microsoft.Build.Framework/$(doc_en)                     \
	$(classdir)/Microsoft.Build.Utilities/$(doc_en)                     \
	$(classdir)/System.Configuration.Install/$(doc_en)                  \
	$(classdir)/System.Core/$(doc_en)                                   \
	$(classdir)/System.Data/$(doc_en)                                   \
	$(classdir)/System.Design/$(doc_en)                                 \
	$(classdir)/System.DirectoryServices/$(doc_en)                      \
	$(classdir)/System.Drawing/$(doc_en)                                \
	$(classdir)/System.Json/$(doc_en)                                   \
	$(classdir)/System.Net.Http/$(doc_en)                               \
	$(classdir)/System.Runtime.Remoting/$(doc_en)                       \
	$(classdir)/System.Runtime.Serialization/$(doc_en)                  \
	$(classdir)/System.Runtime.Serialization.Formatters.Soap/$(doc_en)  \
	$(classdir)/System.Security/$(doc_en)                               \
	$(classdir)/System.ServiceModel/$(doc_en)                           \
	$(classdir)/System.Web.Services/$(doc_en)                           \
	$(classdir)/System.Web/$(doc_en)                                    \
	$(classdir)/System.XML/$(doc_en)                                    \
	$(classdir)/System.Xml.Linq/$(doc_en)                               \
	$(classdir)/System/$(doc_en) 

MONO_DIRS = \
	$(classdir)/Commons.Xml.Relaxng/$(doc_en)          \
	$(classdir)/Mono.Cairo/$(doc_en)                   \
	$(classdir)/Mono.CSharp/$(doc_en)                  \
	$(classdir)/Mono.Data.Sqlite/$(doc_en)		   \
	$(classdir)/Mono.Debugger.Soft/$(doc_en)           \
	$(classdir)/Mono.Options/$(doc_en)                 \
	$(classdir)/Mono.Parallel/$(doc_en)		   \
	$(classdir)/Mono.Posix/$(doc_en)                   \
	$(classdir)/Mono.Security.Win32/$(doc_en)          \
	$(classdir)/Mono.Security/$(doc_en)                \
	$(classdir)/Mono.Simd/$(doc_en)

NOVELL_DIRS = \
	$(topdir)/class/Novell.Directory.Ldap/Documentation/en

NUNIT_DIRS = \
	$(topdir)/nunit20/core/$(doc_en)       \
	$(topdir)/nunit20/framework/$(doc_en)  \
	$(topdir)/nunit20/mocks/$(doc_en)      \
	$(topdir)/nunit20/util/$(doc_en)

# To support `make -jN`, we can't mention multiple targets in the same rule;
# DO NOT DO THIS:
#
#	  foo.tree foo.zip : Makefile
#     $(MDOC) assemble -o foo $(FOO_DIRS)
#
# If you do, make will try to biuld foo.tree & foo.zip concurrently, which
# breaks things badly... (read: "mdoc: sharing violation on path...foo.zip").
#
# The proper solution is to chain the rule dependencies so that only one file
# is the target of a rule.

netdocs.zip : netdocs.tree
netdocs.tree: Makefile
	$(MDOC) --debug assemble -o netdocs $(NETDOCS_DIRS)

Mono.zip : Mono.tree
Mono.tree: Makefile
	$(MDOC) --debug assemble -o Mono $(MONO_DIRS)

Novell.zip : Novell.tree
Novell.tree: Makefile
	$(MDOC) --debug assemble -o Novell $(NOVELL_DIRS)

cs-errors.zip : cs-errors.tree
cs-errors.tree: cs-errors.config Makefile
	$(MDOC) --debug assemble -o cs-errors -f error $<

ecma334.zip : ecma334.tree
ecma334.tree: Makefile
	$(MDOC) --debug assemble -o ecma334 -f ecmaspec ecma334

=== mcs/ilasm/Makefile ===
thisdir = ilasm
SUBDIRS =
include ../build/rules.make

PROGRAM = ilasm.exe
BUILT_SOURCES = ILParser.cs

LIB_REFS = PEAPI System

API_BUILD := $(filter build, $(PROFILE))
ifdef API_BUILD
TARGET_NET_REFERENCE = $(BOOTSTRAP_BIN_PROFILE)
PROGRAM_USE_INTERMEDIATE_FILE = 1
else
LIB_REFS += Mono.Security
LOCAL_MCS_FLAGS += -d:HAS_MONO_SECURITY
endif

CLEAN_FILES = parser/y.output

EXTRA_DISTFILES = \
	parser/ILParser.jay	\
	$(wildcard tests/*.il)

ILParser.cs: parser/ILParser.jay $(topdir)/jay/skeleton.cs
	$(topdir)/jay/jay -ct -o $@ $(CURDIR)/$< < $(topdir)/jay/skeleton.cs

include ../build/executable.make

=== mcs/jay/Makefile ===
thisdir := jay
SUBDIRS := 
include ../build/rules.make

LOCAL_CFLAGS = -DSKEL_DIRECTORY=\""$(prefix)/share/jay"\"
NO_INSTALL = yes

sources = closure.c error.c lalr.c lr0.c main.c mkpar.c output.c reader.c \
          symtab.c verbose.c warshall.c

datafiles = ACKNOWLEDGEMENTS NEW_FEATURES NOTES README README.jay skeleton \
            skeleton.cs

DISTFILES = $(datafiles) $(sources) jay.1 $(wildcard *.h) jay.vcxproj

all-local: jay

install-local:
uninstall-local:

ifndef NO_INSTALL
install-local: jay
	$(MKINSTALLDIRS) $(DESTDIR)$(prefix)/bin
	$(MKINSTALLDIRS) $(DESTDIR)$(prefix)/share/jay
	$(MKINSTALLDIRS) $(DESTDIR)$(prefix)/share/man/man1
	$(INSTALL_BIN) jay $(DESTDIR)$(prefix)/bin
	for datafile in $(datafiles) ; do \
	   $(INSTALL_DATA) $$datafile $(DESTDIR)$(prefix)/share/jay ; \
	done
	$(INSTALL_DATA) jay.1 $(DESTDIR)$(prefix)/share/man/man1

uninstall-local:
	-rm -f $(DESTDIR)$(prefix)/bin/jay
	for datafile in $(datafiles) ; do \
	   rm -f $(DESTDIR)$(prefix)/share/jay/$$datafile || : ; \
	done
	-rm -f $(DESTDIR)$(prefix)/share/man/man1/jay.1
endif

clean-local:
	rm -f jay *.o *.exe *.pdb

dist-local: dist-default

test-local run-test-local run-test-ondotnet-local doc-update-local:

ifndef ENABLE_MSVC_ONLY

jay: $(sources:.c=.o)
	$(CCOMPILE) $(LDFLAGS) -o $@ $^

%.o: %.c
	$(CCOMPILE) $(JAY_CFLAGS) -c -o $@ $^

else # !ENABLE_MSVC_ONLY

jay:
	make -C $(topdir)/../msvc jay

endif # !ENABLE_MSVC_ONLY

=== mcs/tools/Makefile ===
thisdir = tools

net_4_5_dirs := \
	al		\
	aprofutil	\
	linker		\
	culevel		\
	genxs		\
	mkbundle	\
	monop		\
	mono-service	\
	mono-xsd	\
	resgen		\
	wsdl		\
	xbuild		\
	csharp		\
	corcompare	\
	mono-api-diff \
	mono-api-html \
	compiler-tester	\
	mono-xmltool	\
	mono-shlib-cop	\
	sgen		\
	mconfig		\
	installutil	\
	nunitreport	\
	pdb2mdb		\
	sqlsharp	\
	sqlmetal	\
	svcutil		\
	ictool		\
	disco		\
	soapsuds	\
	browsercaps-updater	\
	cil-strip	\
	macpack		\
	dtd2rng		\
	dtd2xsd		\
	mdoc		\
	mod		\
	installvst	\
	lc		\
	mono-configuration-crypto \
	ccrewrite	\
	cccheck		\
	security	\
	mdbrebase	\
	mdb2ppdb	\
	ikdasm		\
	mono-symbolicate	\
	linker-analyzer \
	gacutil

build_SUBDIRS =
build_PARALLEL_SUBDIRS := resgen gacutil security culevel commoncryptogenerator resx2sr linker cil-strip corcompare mono-api-diff mono-api-html
monodroid_tools_SUBDIRS =
monodroid_tools_PARALLEL_SUBDIRS = aprofutil cil-strip linker-analyzer mkbundle mdoc mono-symbolicate corcompare mono-api-diff mono-api-html pdb2mdb nunit-lite
monodroid_SUBDIRS = nunit-lite
monotouch_SUBDIRS = nunit-lite
monotouch_tv_SUBDIRS = nunit-lite
monotouch_watch_SUBDIRS = nunit-lite
monotouch_tools_SUBDIRS =
monotouch_tools_PARALLEL_SUBDIRS = corcompare mono-api-html
xammac_SUBDIRS = nunit-lite
xammac_net_4_5_SUBDIRS = nunit-lite
net_4_x_SUBDIRS =
net_4_x_PARALLEL_SUBDIRS = $(net_4_5_dirs)
wasm_tools_SUBDIRS =
wasm_tools_PARALLEL_SUBDIRS = linker wasm-tuner cil-strip

DIST_SUBDIRS = $(net_4_5_dirs) cil-stringreplacer commoncryptogenerator resx2sr gensources

include ../build/rules.make

DISTFILES = \
	removecomments.sh

test-local run-test-local run-test-ondotnet-local all-local install-local uninstall-local doc-update-local:
	@:

dist-local: dist-default

clean-local:
	rm -f *.exe *.dll *.pdb cormissing.xml

=== mono/btls/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.10...4.0)

project (mono-btls)

enable_language(C)
enable_language(CXX)

find_program(CCACHE_PROGRAM ccache)
if(CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
endif()

if (MSVC OR CYGWIN)
	set(BTLS_HOST_WIN32 1)
endif ()

if (NOT OPENSSL_NO_ASM)
	if (BTLS_HOST_WIN32)
		if (CYGWIN AND "${BTLS_ARCH}" STREQUAL "i386")
			set(CMAKE_ASM_NASM_OBJECT_FORMAT win32)
		elseif (CYGWIN AND "${BTLS_ARCH}" STREQUAL "x86_64")
			set(CMAKE_ASM_NASM_OBJECT_FORMAT win64)
		endif ()
		enable_language(ASM_NASM)
	else ()
		# FIXME: cmake's asm detection is broken when using xcrun.
		set (CMAKE_ASM_COMPILER "${CMAKE_C_COMPILER}")
		set (CMAKE_ASM_COMPILER_ARG1 "${CMAKE_C_COMPILER_ARG1}")
		set (CMAKE_ASM_COMPILER_ID "${CMAKE_C_COMPILER_ID}")
		enable_language(ASM)
	endif ()
endif ()

if (NOT "${BTLS_ARCH}" STREQUAL "")
	message (STATUS "SET ARCH: ${BTLS_ARCH}")
	set (CMAKE_SYSTEM_PROCESSOR "${BTLS_ARCH}")
endif ()

if (NOT MSVC)
	if(${CMAKE_SYSTEM_NAME} MATCHES "AIX" OR ${CMAKE_SYSTEM_NAME} MATCHES "OS400")
		# GCC+XCOFF doesn't support -fvisibility=hidden, and we would prefer XCOFF debugging info.
		set (C_CXX_FLAGS "-Wall -Wsign-compare -Wmissing-field-initializers -fPIC -gxcoff")
	else()
		set (C_CXX_FLAGS "-Wall -Wsign-compare -Wmissing-field-initializers -fPIC -ggdb -fvisibility=hidden")
	endif()

	set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_CXX_FLAGS} ${BTLS_CFLAGS}")
	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${C_CXX_FLAGS} ${BTLS_CFLAGS}")
else ()
	set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${BTLS_CFLAGS}")
	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${BTLS_CFLAGS}")
endif ()

if (NOT OPENSSL_NO_ASM)
	if (BTLS_HOST_WIN32)
		set (CMAKE_ASM_NASM_FLAGS "${CMAKE_ASM_NASM_FLAGS} ${BTLS_CFLAGS}")
	else ()
		set (CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${BTLS_CFLAGS}")
	endif ()
endif ()

set (CMAKE_MACOSX_RPATH 1)
set (MONO_BTLS 1)

set(BUILD_SHARED_LIBS_SAVED "${BUILD_SHARED_LIBS}")
set(BUILD_SHARED_LIBS OFF)
add_subdirectory (${BTLS_ROOT} boringssl)
set(BUILD_SHARED_LIBS "${BUILD_SHARED_LIBS_SAVED}")

include_directories (
	${SRC_DIR}
	${BTLS_ROOT}/include
)

set (
	MONO_BTLS_SOURCES

	btls-bio.c
	btls-bio.h
	btls-error.c
	btls-error.h
	btls-key.c
	btls-key.h
	btls-pkcs12.c
	btls-pkcs12.h
	btls-ssl-ctx.c
	btls-ssl-ctx.h
	btls-ssl.c
	btls-ssl.h
	btls-time64.c
	btls-util.c
	btls-util.h
	btls-x509-chain.c
	btls-x509-chain.h
	btls-x509-crl.c
	btls-x509-crl.h
	btls-x509-lookup.c
	btls-x509-lookup.h
	btls-x509-lookup-mono.c
	btls-x509-lookup-mono.h
	btls-x509-name.c
	btls-x509-name.h
	btls-x509-revoked.c
	btls-x509-revoked.h
	btls-x509-store-ctx.c
	btls-x509-store-ctx.h
	btls-x509-store.c
	btls-x509-store.h
	btls-x509-verify-param.c
	btls-x509-verify-param.h
	btls-x509.c
	btls-x509.h

	${BORINGSSL_OBJECTS}
)

add_library (mono-btls-shared SHARED ${MONO_BTLS_SOURCES})

if (BTLS_HOST_WIN32)
	set (CMAKE_SHARED_LIBRARY_PREFIX "lib")
endif ()

if (CYGWIN)
	target_link_libraries (mono-btls-shared wsock32 ws2_32)
endif ()

=== external/api-doc-tools/monodoc/Makefile ===
CONFIGURATION = Release

check: 
	mono ../packages/NUnit.ConsoleRunner.3.6.0/tools/nunit3-console.exe Test/bin/$(CONFIGURATION)/Monodoc.Test.dll
	@echo "monodoc Tests Complete!"

=== debian/changelog ===
mono (6.14.1+ds2-1) unstable; urgency=medium

  [ Aurelien Jarno ]
  * Improve ability to build mono on riscv64.

  [ Helmut Grohne ]
  * Tell boehm gc to use gcc atomic intrinsics,
    improving the ability to cross build.
    (Closes: #1112632)

  [ Antoine Le Gonidec ]
  * New source repack excluding more generated files.
  * Add missing Breaks/Replaces for mono-dbg.
  * Fix typo in Breaks/Replaces for mono-csharp-shell.
  * Fix ability to install mono-devel alongside cli-common-dev.
  * Fix build of shipped Boehm's GC to no longer rely on vendored generated
    files.
  * Drop binfmt integration.
  * Drop multiple unused Debian-specific scripts.
  * Drop unused Debian-specific .gitignore.
  * Drop unused XDG desktop menu entries.

 -- Antoine Le Gonidec <vv221@debian.org>  Mon, 01 Sep 2025 15:00:08 +0200

mono (6.14.1+ds-6) unstable; urgency=medium

  * Stop trying to kill all mono processes during tests.
    (Closes: #759496, #962022)
  * Fix build without Boehm's garbage collector on arm64.
  * Provide dh_makeclilibs to source packages that build-depend on mono-devel.
  * Reduce the amount of build-dependencies.

 -- Antoine Le Gonidec <vv221@debian.org>  Tue, 26 Aug 2025 13:29:11 +0200

mono (6.14.1+ds-5) unstable; urgency=medium

  * Restore missing dependency on libgdiplus.
    (Closes: #1111930)
  * Import upstream patch to fix build on arm64.
  * Fix dependencies of autopkgtest.
  * Drop fake manpages.

 -- Antoine Le Gonidec <vv221@debian.org>  Sun, 24 Aug 2025 13:18:32 +0200

mono (6.14.1+ds-4) unstable; urgency=medium

  * Drop CLI (.NET) dependencies resolution.
    (Closes: #695555, #1111419)
  * Drop generation of a Mono certificates store.
    (Closes: #821831)
  * Ensure all maintainer scripts exit on error.
    (Closes: #866269)
  * Drop integration with cli-common.
    (Closes: #1111276)
  * Move debug scripts to -dbgsym packages.
  * Drop obsolete dh_gencontrol override.
  * Fix permissions on many files.
  * Fix generation and removal of AOT libraries.
  * Fix ability to install mono-libraries without mono-runtime.
  * Restore full Debian changelog.
  * Silence some lintian false-positives.

 -- Antoine Le Gonidec <vv221@debian.org>  Wed, 20 Aug 2025 17:06:31 +0200

mono (6.14.1+ds-3) experimental; urgency=medium

  * Add support for extra architectures: loong64 and riscv64.
    (Closes: #1111092)
  * Rename libmono-corlib4.5-cil binary package to mono-libraries.
  * Rename mono-dbg binary package to mono-libraries-debug.
  * Merge several packages into mono-runtime.
  * Merge all development packages into mono-devel.
  * Drop debian/NEWS about libraries merge,
    as most users probably do not care.
  * Migrate to -dbgsym debug packages.

 -- Antoine Le Gonidec <vv221@debian.org>  Fri, 15 Aug 2025 22:04:02 +0200

mono (2.6.3-4) experimental; urgency=low

  * Backported fix from upstream SVN revision r158081, which corrects
    xbuild's handling of wildcards with directories. This fixes a bug
    which prevents Pinta 0.4 from being built. Thanks to Ankit Jain
    <jankit@novell.com>

 -- Jo Shields <directhex@apebox.org>  Wed, 07 Jul 2010 10:56:17 +0100

mono (2.6.3-3) experimental; urgency=low

  * git:debian/patches/arm_cpuinfo_parsing:
    + Fix bug in QEMU-friendly ARM CPU capability parsing, by setting
      v7_supported explicitly to FALSE on non-QEMU hardware, unless
      a v7 CPU is detected (previously it was MAYBE, so v7 instructions
      were always generated)

 -- Jo Shields <directhex@apebox.org>  Thu, 01 Jul 2010 00:38:28 +0100

mono (2.6.3-2) experimental; urgency=low

  * git:debian/patches/kfreebsd_support:
    + Ensure all FreeBSD ifdefs also apply to kFreeBSD
    + Use &ctx->uc_mcontext, not &ctx->uc_mcontext.gregs, on FreeBSD kernels
    + Ensure kFreeBSD follows POSIX signal code paths
    + (Closes: #585662)
  * git:debian/patches/fix_GetTypeDescriptor_wrapped_type_call_forwarding_r157626:
    + Backport from upstream SVN repository to fix upstream bug 603060, which
      causes TypeDescriptorProvider to return false values on wrapped types
  * git:debian/patches/insecure_EnableViewStateMac_XSS_CVE-2010-1459:
    + Backport from upstream SVN repository to fix CVE-2010-1459, which
      implies that the default value for EnableViewStateMac can potentially
      allow XSS attacks against ASP.NET sites hosted on Mono
      (Closes: #585440)
  * debian/update-monodoc:
    + Updated script from Iain Lane <laney@ubuntu.com> which no longer fails
      when called using bash rather than dash (Closes: #580665)
  * debian/control:
    + Add a Replaces: on libmono-dev << 2.4.3 (Closes: #582614)
  * debian/control,
    debian/libmono{1,0}.0-cil.install,
    debian/mono-{1,2}.0-service.install:
    + Move mono-service executables' GAC entries to mono-service packages
      where they belong (Closes: #586192)

 -- Jo Shields <directhex@apebox.org>  Tue, 22 Jun 2010 08:53:51 +0100

mono (2.6.3-1) experimental; urgency=low

  * New upstream release (Closes: #572901)
    + Soft debugger
    + Co-routine framework Mono.Tasklets
    + Auto-completion for the csharp shell
    + LINQ to SQL
    + Enhanced XBuild
    + Mono.Simd for AMD64
    + Verifier and Sandbox (used by Moonlight)
    + Debugging support for GDB

  * The "Good bye dpatch, hello git" release
  * debian/control
    debian/rules
    debian/patches/*:
    + Replaced dpatches with git branches.

  * debian/mono-dbg.install:
    + Added mono-gdb.py script for gdb integration
  * debian/control
    debian/libmono-debugger-soft0.0-cil.install:
    + New package for the soft debugger library.
  * debian/libmono-microsoft-build2.0-cil.install:
    + Added new libraries.
  * debian/control
    debian/libmono-c5-1.0-cil.install
    debian/libmono-c5-1.1-cil.install:
    + Renamed the libmono-c5-1.0-cil package to libmono-c5-1.1-cil as the
      assembly version changed.
  * debiab/control
    debian/libmono-tasklets2.0-cil.install:
    + New package for the continuations library.


=== debian/control ===
Source: mono
Section: cli-mono
Priority: optional
Maintainer: Antoine Le Gonidec <vv221@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: http://www.mono-project.com/
Vcs-Git: https://salsa.debian.org/dotnet-team/mono.git
Vcs-Browser: https://salsa.debian.org/dotnet-team/mono

Package: mono-runtime
Architecture: amd64 arm64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 loong64 mipsel powerpc ppc64 ppc64el riscv64 s390x
Provides:
 cli-runtime, cli-virtual-machine,
 global-assembly-cache-tool,
 mono-runtime-boehm (= ${source:Version}) [amd64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 loong64 mipsel powerpc ppc64 ppc64el s390x],
 mono-runtime-common (= ${source:Version}),
 mono-runtime-sgen (= ${source:Version}),
Breaks:
 mono-gac (<< 6.14.1+ds-3),
 mono-runtime-boehm (<< 6.14.1+ds-3),
 mono-runtime-common (<< 6.14.1+ds-3),
 mono-runtime-sgen (<< 6.14.1+ds-3),
Replaces:
 mono-gac (<< 6.14.1+ds-3),
 mono-runtime-boehm (<< 6.14.1+ds-3),
 mono-runtime-common (<< 6.14.1+ds-3),
 mono-runtime-sgen (<< 6.14.1+ds-3),
Depends:
 binutils,
 mono-libraries,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Framework Mono - runtime binaries
 Framework Mono is a software platform designed to allow developers to easily
 create cross platform applications. It is an open source implementation
 of Microsoft's .NET Framework based on the ECMA standards for C# and the
 Common Language Runtime.
 .
 This package contains the architecture-specific parts of Framework Mono runtime
 that are required to run software written in C#.

Package: mono-libraries
Architecture: all
Multi-Arch: foreign
Depends:
 libgdiplus,
 ${misc:Depends},
Breaks:
 libmono-corlib4.5-cil (<< 6.14.1+ds-3),
 libmono-accessibility4.0-cil (<< 6.12.0.199+ds-2),
 libmono-btls-interface4.0-cil (<< 6.12.0.199+ds-2),
 libmono-c5-1.1-cil (<< 6.12.0.199+ds-2),
 libmono-cairo4.0-cil (<< 6.12.0.199+ds-2),
 libmono-cecil-private-cil (<< 6.12.0.199+ds-2),
 libmono-codecontracts4.0-cil (<< 6.12.0.199+ds-2),
 libmono-compilerservices-symbolwriter4.0-cil (<< 6.12.0.199+ds-2),
 libmono-corlib4.5-dll (<< 6.12.0.199+ds-2),
 libmono-cscompmgd0.0-cil (<< 6.12.0.199+ds-2),
 libmono-csharp4.0c-cil (<< 6.12.0.199+ds-2),
 libmono-custommarshalers4.0-cil (<< 6.12.0.199+ds-2),
 libmono-data-tds4.0-cil (<< 6.12.0.199+ds-2),
 libmono-db2-1.0-cil (<< 6.12.0.199+ds-2),
 libmono-debugger-soft4.0a-cil (<< 6.12.0.199+ds-2),
 libmono-http4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-cjk4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-mideast4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-other4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-rare4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-west4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n4.0-cil (<< 6.12.0.199+ds-2),
 libmono-ldap4.0-cil (<< 6.12.0.199+ds-2),
 libmono-management4.0-cil (<< 6.12.0.199+ds-2),
 libmono-messaging-rabbitmq4.0-cil (<< 6.12.0.199+ds-2),
 libmono-messaging4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build-engine4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build-framework4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build-tasks-v4.0-4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build-utilities-v4.0-4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-csharp4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-visualc10.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-web-infrastructure1.0-cil (<< 6.12.0.199+ds-2),
 libmono-oracle4.0-cil (<< 6.12.0.199+ds-2),
 libmono-parallel4.0-cil (<< 6.12.0.199+ds-2),
 libmono-peapi4.0a-cil (<< 6.12.0.199+ds-2),
 libmono-posix4.0-cil (<< 6.12.0.199+ds-2),
 libmono-rabbitmq4.0-cil (<< 6.12.0.199+ds-2),
 libmono-relaxng4.0-cil (<< 6.12.0.199+ds-2),
 libmono-security4.0-cil (<< 6.12.0.199+ds-2),
 libmono-sharpzip4.84-cil (<< 6.12.0.199+ds-2),
 libmono-simd4.0-cil (<< 6.12.0.199+ds-2),
 libmono-smdiagnostics0.0-cil (<< 6.12.0.199+ds-2),
 libmono-sqlite4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-componentmodel-composition4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-componentmodel-dataannotations4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-configuration4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-configuration-install4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-core4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-data-datasetextensions4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-data-entity4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-data-linq4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-data-services-client4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-data-services4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-data4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-deployment4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-design4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-drawing-design4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-drawing4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-dynamic4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-enterpriseservices4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-identitymodel-selectors4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-identitymodel4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-io-compression-filesystem4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-io-compression4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-json-microsoft4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-json4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-ldap-protocols4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-ldap4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-management4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-messaging4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-net-http-formatting4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-net-http-webrequest4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-net-http4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-net4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-numerics-vectors4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-numerics4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-core2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-debugger2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-experimental2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-interfaces2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-linq2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-observable-aliases0.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-platformservices2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-providers2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-runtime-remoting2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-windows-forms2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reactive-windows-threading2.2-cil (<< 6.12.0.199+ds-2),
 libmono-system-reflection-context4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-runtime-caching4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-runtime-durableinstancing4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-runtime-serialization-formatters-soap4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-runtime-serialization4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-runtime4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-security4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-servicemodel-activation4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-servicemodel-discovery4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-servicemodel-internals0.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-servicemodel-routing4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-servicemodel-web4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-servicemodel4.0a-cil (<< 6.12.0.199+ds-2),
 libmono-system-serviceprocess4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-threading-tasks-dataflow4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-transactions4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-abstractions4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-applicationservices4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-dynamicdata4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-extensions-design4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-extensions4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-http-selfhost4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-http-webhost4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-http4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-mobile4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-mvc3.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-razor2.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-regularexpressions4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-routing4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-services4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-webpages-deployment2.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-webpages-razor2.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web-webpages2.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-web4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-windows-forms-datavisualization4.0a-cil (<< 6.12.0.199+ds-2),
 libmono-system-windows-forms4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-windows4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-workflow-activities4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-workflow-componentmodel4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-workflow-runtime4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-xaml4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-xml-linq4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-xml-serialization4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system-xml4.0-cil (<< 6.12.0.199+ds-2),
 libmono-system4.0-cil (<< 6.12.0.199+ds-2),
 libmono-tasklets4.0-cil (<< 6.12.0.199+ds-2),
 libmono-wcf4.0-cil (<< 6.12.0.199+ds-2),
 libmono-webbrowser4.0-cil (<< 6.12.0.199+ds-2),
 libmono-webmatrix-data4.0-cil (<< 6.12.0.199+ds-2),
 libmono-windowsbase4.0-cil (<< 6.12.0.199+ds-2),
 libmono-xbuild-tasks4.0-cil (<< 6.12.0.199+ds-2),
 mono-4.0-gac (<< 6.14.1+ds-3),
 mono-gac (<< 6.14.1+ds-3),
Replaces:
 libmono-corlib4.5-cil (<< 6.14.1+ds-3),
 libmono-accessibility4.0-cil (<< 6.12.0.199+ds-2),
 libmono-btls-interface4.0-cil (<< 6.12.0.199+ds-2),
 libmono-c5-1.1-cil (<< 6.12.0.199+ds-2),
 libmono-cairo4.0-cil (<< 6.12.0.199+ds-2),
 libmono-cecil-private-cil (<< 6.12.0.199+ds-2),
 libmono-codecontracts4.0-cil (<< 6.12.0.199+ds-2),
 libmono-compilerservices-symbolwriter4.0-cil (<< 6.12.0.199+ds-2),
 libmono-corlib4.5-dll (<< 6.12.0.199+ds-2),
 libmono-cscompmgd0.0-cil (<< 6.12.0.199+ds-2),
 libmono-csharp4.0c-cil (<< 6.12.0.199+ds-2),
 libmono-custommarshalers4.0-cil (<< 6.12.0.199+ds-2),
 libmono-data-tds4.0-cil (<< 6.12.0.199+ds-2),
 libmono-db2-1.0-cil (<< 6.12.0.199+ds-2),
 libmono-debugger-soft4.0a-cil (<< 6.12.0.199+ds-2),
 libmono-http4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-cjk4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-mideast4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-other4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-rare4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n-west4.0-cil (<< 6.12.0.199+ds-2),
 libmono-i18n4.0-cil (<< 6.12.0.199+ds-2),
 libmono-ldap4.0-cil (<< 6.12.0.199+ds-2),
 libmono-management4.0-cil (<< 6.12.0.199+ds-2),
 libmono-messaging-rabbitmq4.0-cil (<< 6.12.0.199+ds-2),
 libmono-messaging4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build-engine4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build-framework4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build-tasks-v4.0-4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build-utilities-v4.0-4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-build4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-csharp4.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-visualc10.0-cil (<< 6.12.0.199+ds-2),
 libmono-microsoft-web-infrastructure1.0-cil (<< 6.12.0.199+ds-2),
 libmono-oracle4.0-cil (<< 6.12.0.199+ds-2),
 libmono-parallel4.0-cil (<< 6.12.0.199+ds-2),
 libmono-peapi4.0a-cil (<< 6.12.0.199+ds-2),
 libmono-posix4.0-cil (<< 6.12.0.199+ds-2),
 libmono-rabbitmq4.0-cil (<< 6.12.0.199+ds-2),
 libmono-relaxng4.0-cil (<< 6.12.0.199+ds-2),
 libmono-security4.0-cil (<< 6.12.0.199+ds-2),
 libmono-sharpzip4.84-cil (<< 6.12.0.199+ds-2),
 libmono-simd4.0-cil (<< 6.12.0.199+ds-2),

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

# bring in VERSION/ARCH/BUILD variables
include /usr/share/dpkg/default.mk
include debian/mono-archs.make

RUN_MONO = MONO_PATH=debian/tmp/usr/lib/mono/4.5 runtime/mono-wrapper
DH_INTERNAL_MONO_PARAM = --internal-mono

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	CONF_FLAGS += --build $(DEB_HOST_GNU_TYPE)
else
	CONF_FLAGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

ifeq ($(DEB_HOST_ARCH_OS), kfreebsd)
	CONF_FLAGS += --enable-minimal=aot
endif

ifeq ($(DEB_HOST_ARCH), armel)
	CONF_FLAGS += --with-fpu=NONE --with-tls=pthread
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), armhf)
	CONF_FLAGS += --with-tls=pthread
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), arm64)
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), i386)
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), amd64)
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), mipsel)
	CONF_FLAGS += --with-tls=pthread
else ifeq ($(DEB_HOST_ARCH), powerpc)
	CONF_FLAGS += --with-tls=pthread
else ifeq ($(DEB_HOST_ARCH), ppc64)
	CONF_FLAGS += --with-tls=pthread
else ifeq ($(DEB_HOST_ARCH), ppc64el)
	CONF_FLAGS += --with-tls=pthread
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), riscv64)
	BTLS_ARCH = true
else ifeq ($(DEB_HOST_ARCH), s390x)
	BTLS_ARCH = true
endif

ifneq (,$(findstring $(DEB_HOST_ARCH),$(DEB_MONO_SGEN_ARCHS)))
	CONF_FLAGS += --with-sgen=yes
else
	CONF_FLAGS += --with-sgen=no
endif

# Skip building Boehm's garbage collector on unsupported architectures.
ifeq (,$(findstring $(DEBHOST_ARCH),$(DEB_MONO_BOEHM_ARCHS)))
	DISABLE_BOEHM = true
endif
ifdef DISABLE_BOEHM
	CONF_FLAGS += --disable-boehm
endif
# Set Boehm's garbage collector build flags.
ifndef DISABLE_BOEHM
	CONFIGURE_BOEHM = \
		--prefix=/usr/local --cache-file=/dev/null --srcdir=. \
		--no-create --no-recursion \
		--with-libgc-threads=pthreads \
		--enable-parallel-mark --enable-maintainer-mode --enable-compile-warnings --enable-single-obj-compilation \
		--disable-option-checking --disable-embed-check \
		CFLAGS_FOR_LIBGC='-Wno-deprecated-declarations -g -mno-tls-direct-seg-refs' \
		CPPFLAGS_FOR_LIBGC='-Wall -Wunused -Wmissing-declarations -Wpointer-arith -Wno-cast-qual -Wwrite-strings -Wno-switch -Wno-switch-enum -Wno-unused-value -Wno-attributes -DGC_LINUX_THREADS -D_GNU_SOURCE -D_REENTRANT -DUSE_MMAP -DUSE_MUNMAP -g -DUSE_COMPILER_TLS'
endif

%:
	dh $@

CONFIGURE = --libdir=/usr/lib/ --libexecdir=/usr/lib/ \
	--with-ikvm-native=no --disable-quiet-build --with-csc=mcs \
	--disable-system-aot --enable-llvm=no --enable-loadedllvm=no \
	--with-libatomic-ops=none \
	$(CONF_FLAGS)


ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MONO_MAKE_FLAGS += -j$(NUMJOBS)
endif

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE)

execute_after_dh_auto_configure:
ifndef DISABLE_BOEHM
	env --chdir=external/bdwgc ./configure $(CONFIGURE_BOEHM)
endif

execute_before_dh_auto_build:
ifndef DISABLE_BOEHM
	env --chdir=external/bdwgc $(MAKE) $(MONO_MAKE_FLAGS)
endif

override_dh_auto_build:
	cd mono/eglib && $(MAKE) $(MONO_MAKE_FLAGS)
	cd mono && $(MAKE) $(MONO_MAKE_FLAGS)
	LC_ALL=C $(MAKE) $(MAKE_FLAGS) EXTERNAL_MCS=false EXTERNAL_MONO=false

	chmod +x debian/dh_makeclilibs \
	         debian/dh_clistrip
	cp -a ./external/binary-reference-assemblies/v4.7.1 ./external/binary-reference-assemblies/v4.7.1.debbak
	find ./external/binary-reference-assemblies/v4.7.1/ -name \*.dll -print -delete
	MONO_PATH=$(CURDIR)/mcs/class/lib/net_4_x-linux/ $(MAKE) $(MONO_MAKE_FLAGS) -C external/binary-reference-assemblies/ \
		V=$(DH_VERBOSE) CSC="$(CURDIR)/runtime/mono-wrapper $(CURDIR)/mcs/class/lib/net_4_x-linux/mcs.exe"
	# Build the late-GAC tool, using the built Mono runtime
	MONO_PATH=$(CURDIR)/mcs/class/lib/net_4_x-linux/ runtime/mono-wrapper \
		mcs/class/lib/net_4_x-linux/mcs.exe -target:exe \
		-out:debian/MonoGetAssemblyName.exe debian/MonoGetAssemblyName.cs

override_dh_auto_test:
	-cd mono/mini && timeout -k 15m 1h make check
	-cd mono/tests && MONO_ENV_OPTIONS="$(MONO_ENV_OPTIONS) --gc=boehm" timeout -k 15m 1h make check
	-cd mono/tests && MONO_ENV_OPTIONS="$(MONO_ENV_OPTIONS) --gc=sgen" timeout -k 15m 1h make check
	# funny bug-459094.cs creates too long directory names which
	# pbuilder is unable to remove, eh
	rm -rf mono/tests/abcde12345abcde12345abcde12345abcde12345/

override_dh_auto_clean:
ifneq ("$(wildcard external/binary-reference-assemblies/v4.7.1.debbak)","")
		rm -rf external/binary-reference-assemblies/v4.7.1
		mv external/binary-reference-assemblies/v4.7.1.debbak external/binary-reference-assemblies/v4.7.1
endif
	[ ! -f Makefile ] || $(MAKE) distclean
	# distclean misses stuff
	find -name "*.mdb" -delete
	find ./external/binary-reference-assemblies/ -name "*.dll" -not -path "./external/binary-reference-assemblies/v4.7.1/*" -print -delete
	rm -rf mcs/class/lib/basic/ \
	       mcs/class/lib/net_4_5/
	rm -f debian/MonoGetAssemblyName.exe
	rm -f mcs/packages/*.dll mcs/packages/*.exe* mcs/packages/*.rsp
	dh_auto_clean

execute_before_dh_install:
	# Boehm's garbage collector is not built on all architectures,
	# so can not be handled by debian/${pkg}.install files.
ifndef DISABLE_BOEHM
	install -D --mode=755 \
		--target-directory=debian/mono-runtime/usr/bin/ \
		debian/tmp/usr/bin/mono-boehm
	install -D --mode=644 \
		--target-directory=debian/mono-devel/usr/lib/ \
		debian/tmp/usr/lib/libmonoboehm-2.0.a \
		debian/tmp/usr/lib/libmonoboehm-2.0.so.1.0.0
	## install always dereference symbolic links,
	## so we need to create them explicitly.
	ln --symbolic libmonoboehm-2.0.so.1.0.0 \
		debian/mono-devel/usr/lib/libmonoboehm-2.0.so.1
	ln --symbolic libmonoboehm-2.0.so.1 \
		debian/mono-devel/usr/lib/libmonoboehm-2.0.so
	rm \
		debian/tmp/usr/bin/mono-boehm \
		debian/tmp/usr/lib/libmonoboehm-2.0.a \
		debian/tmp/usr/lib/libmonoboehm-2.0.so \
		debian/tmp/usr/lib/libmonoboehm-2.0.so.1 \
		debian/tmp/usr/lib/libmonoboehm-2.0.so.1.0.0
endif

execute_after_dh_install:
	cd mcs/jay && \
		$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp
	# don't want docs of bundled libgc
	rm -rf debian/tmp/usr/share/libgc-mono
	# Mono.Security.Win32.dll is only useful on windows, as it wrap the win api
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/Mono.Security.Win32/
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.5/Mono.Security.Win32.dll*
	# we don't ship bundled nunit of mono
	rm -f  $(CURDIR)/debian/tmp/usr/lib/mono/4.5/nunit*
	rm -f  $(CURDIR)/debian/tmp/usr/lib/pkgconfig/mono-nunit.pc
	rm -rf $(CURDIR)/debian/tmp/usr/lib/mono/gac/nunit*/
	rm -f  $(CURDIR)/debian/tmp/usr/bin/nunit*
	# mono 2.10.1 bug, prj2make was removed but the start script not
	rm -f $(CURDIR)/debian/tmp/usr/bin/prj2make
ifndef DISABLE_BOEHM
	strip --strip-unneeded --remove-section=.comment --remove-section=.note \
		debian/tmp/usr/bin/pedump
endif
ifdef BTLS_ARCH
	install -D -m 644 debian/tmp/usr/lib/libmono-btls-shared.so \
		debian/mono-runtime/usr/lib/libmono-btls-shared.so
endif
	# Late GAC
	install -D --mode=644 \
		--target-directory=debian/mono-libraries/usr/lib/mono/gac/System.Data/4.0.0.0__b77a5c561934e089/ \
		debian/System.Data.dll.config
	install -D --mode=644 \
		--target-directory=debian/mono-libraries/usr/lib/mono/gac/System.Drawing/4.0.0.0__b03f5f7f11d50a3a/ \
		debian/System.Drawing.dll.config
	install -D --mode=644 \
		--target-directory=debian/mono-libraries/usr/lib/mono/gac/System.Windows.Forms/4.0.0.0__b77a5c561934e089/ \
		debian/System.Windows.Forms.dll.config
	install -D --mode=644 \
		--target-directory=debian/mono-libraries/usr/lib/mono/gac/Mono.Cairo/4.0.0.0__0738eb9f132ed756/ \
		debian/Mono.Cairo.dll.config
	install -D --mode=644 \
		--target-directory=debian/mono-libraries/usr/lib/mono/gac/Mono.WebBrowser/4.0.0.0__0738eb9f132ed756/ \
		debian/Mono.WebBrowser.dll.config

	debian/dh_clistrip -i --dbg-package=mono-libraries-debug
	debian/dh_makeclilibs -i -m 1.0 $(DH_INTERNAL_MONO_PARAM)

=== debian/tests/control ===
Tests: test-runtime
Depends: mono-runtime, mono-devel
Restrictions: allow-stderr

Tests: test-devel
Depends: mono-devel
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=dversionmangle=s/\+ds2//,repacksuffix=+ds2,compression=xz \
	https://dl.winehq.org/mono/sources/mono/mono-([\d\.]+)\.tar\.xz
